# GAF GotY 2011 comparison script
# usage: similarusers.rb [username]
# PT 2011

users = Hash.new {|hash, key| hash[key] = Array.new(10, rand().to_s) }
urls =  Hash.new {|hash, key| hash[key] = nil }
scores = Hash.new {|hash, key| hash[key] = 0 }

# parse data file
curuser = ""
IO.foreach("data.txt") do |line|
	if line =~ /\A(\S.*)$/ # new user name
		curuser = $1
	elsif line =~ /\s+(\d+)\.(.*)\(..\)/ # game listing
		users[curuser][$1.to_i-1] = $2.strip
	elsif line =~ /\s+(http.*)$/ # url
		urls[curuser] ||= $1.strip
	end
end

# calculate similarity scores
comp = users[ARGV[0]]
users.each do |name, user|
	comp.each_with_index do |cgame, cindex|
		user.each_with_index do |ugame, uindex|
			scores[name] += 25 - (cindex-uindex).abs() - cindex if cgame == ugame
		end
	end
end

# print results
list = scores.keys.sort_by { |k| -scores[k] }

puts "Users with similar selection to #{list[0]}:\n"
list[1..5].each_with_index do |name, i|
	printf("% 3d. % 16s (% 4d) [ %s ]\n", i+1, name, scores[name], urls[name])
end

total = scores.values.reduce(:+)
puts "\nTotal similarity score: #{total}" 
